﻿## What has been completed
**Team Endgame** - *Jan 2022 - May 2022*
| Sprints | Major Tasks | Notes |
|--|--|--|
| **Sprint 1** | Research, research, and even more research| To get up to speed with our new repository, we spent a good deal of our time, as a team, researching our respective technologies that we needed to work with. As we were all spread out across the project in terms of responsibility, it was up to the idividuals on our team to scope our research appropirately,as to what was most important for hit-the-ground running development. This research included findings about, but not limited to: RESTful API, Docker, Swagger, Auto Versioning tools, and the CI/CD Pipeline.|
| | Refactored previous code into YAML |This was the biggest piece of the puzzle as it consisted of refactoring the entire previous code base, that was embedded in the Backend. This was done to ensure that our codebase could operate with RESTful API standards to simplify the transactions between the Frontend and Backend
|              | Added Dev Container |
|              | Planning for Standard Version | In an attempt to create and handle automatic versioning numbers for our API, meetings were held with our technological advisor that pointed us in the direction of Standard Version. A tool that would automatically incrememnt our API version number through various options of automation.  However, with the benefit of hindsight, Standard-Version was later thrown out and the following sprints focused on implementing Semantic Release. A similar tool that was proven on other food pantry systems found within the LFP Network.        |
|	**Sprint 2**		|Introducing/Implementing Semantic Release| Added a plugin into the package to allow an asset to be added to the release, this asset is the Bundled API - Any group wishing to use our API, will simply need to go our releases tab and obtain the newest version of our Bundled API.
|  | Team refactoring and replanning| Through the entirety of Sprint 1 and the beginning of Sprint 2, the BNM community was under the assumption that implementation of the API was the next step in terms of development. This was discussed to be the goal as we assumed that the Frontend and Backend were ready for integration. However, this was not the case, in fact our API was nearly ready to be bundled and shipped off to the other teams for testing, yet the Frontend nor Backend were developed enough to accept an API. This  **led to a change of scope**, one that urged us to assist other teams in their local development in an effort to get them up to speed for API implementation. This meant that our group would have multiple responsibilities across the entire BNM repository. Specifically, Jimmy and Dylan stayed with our team to help further our development regarding the test cases and versioning tools, Royer and Rene helped the Backend with issues regarding endpoint consistency, and Nick went on to help the Frontend with an email verification module. This break up was an unforseen circumstance that was discovered and acted upon by members of our group, alongside the scrum master of the Backend and Frontend teams.
| **Sprint 3** | Update work agreement in regards to team refactor | Due to the change of scope and refactoring of our team in an effort to assist the Frontend and Backend, the working agreement must be updated to guide us through staying organized during our sprint reviews. This included a change that brought upon a new template for issues called the 'linked_issue_spike' template which made it easier for us to identify what was to be done, accross boards and accross team lines. Furthermore, the working agreement specified our newfound deadlines to help team mates stay on task, as well as how we can plan to work with other teamsand calculating work-weight appropriately, while using our cross-board issue linking conventions.
|              | Finalize TCases Implementation| Containerized TCases for use within the developement environment. This allowed the team to start further testing within the api without the need of downloading and installing TCases locally. This also ensures that all contributers are using the same version of TCases throughout the developement and testing of the api. 
|              | Finalize Semantic Release | Implemented Semantic Release, using the bundled API as an asset to incorporate automatic versioning through the pipeline. This will allow the project to automatically incremement its version whenever a change is commit to main. Specifically, the pipeline looks for commit messages the match [Conventional Commits](https://www.conventionalcommits.org/en/v1.0.0/) and uses that information to generate a new version. 
|              | Frontend and Backend assistance | Worked on the Email Verification side of the Frontend. This will allow the Frontend to implemenent verification whenever an email is entered. We also worked on verifying that the Backend paths matched those that were created in the API, as well as verifying that the return status' are correct. This will ensure that we don't run into path errors when implementation begins, as well as ensuring outputs we get report back the correct status.


## Future Steps

- Implement CI/CD Pipeline
- Implement Swagger Testing
- Link with Inventory System